### create a sef from karlsruhe station data ecad to fill the gaps for pressure
rm(list=ls())

source("code/data_prep/scripts/C005_helpfun_ref.R")
source("code/data_prep/scripts/C000_helpfun.R")

outpath <- "code/data_prep/daymeans/refseries/sef/"
refpath <- "data/ecad/ECA_blend_tg/TG_STAID000051.txt"
refper <- c(1961,2020)

dat <- read.table(refpath, header = T, skip=20, sep=",",na.strings=-9999)
meta <- read.table("data/ecad/ECA_blend_tg/stations.txt",
                   skip=19,sep=",",colClasses = rep("character",6), strip.white=T, allowEscapes=T)
meta <- meta[which(meta$V1==dat$STAID[1]),]
lon  <- as.numeric(substr(meta["V5"],2,4))+as.numeric(substr(meta["V5"],6,7))/60+as.numeric(substr(meta["V5"],9,10))/3600
lat  <- as.numeric(substr(meta["V4"],2,3))+as.numeric(substr(meta["V4"],5,6))/60+as.numeric(substr(meta["V4"],8,9))/3600
realend <- which(sapply(1:nrow(dat),function(i) all(is.na(dat[i:nrow(dat),4]))))[1]
if(!is.na(realend)) {dat <- dat[1:(realend-1),]}

out <- data.frame(Year=as.integer(substr(dat$DATE,1,4)),
                  Month=as.integer(substr(dat$DATE,5,6)),
                  Day=as.integer(substr(dat$DATE,7,8)),
                  Hour=rep(24, nrow(dat)),
                  Minute=rep(0, nrow(dat)),
                  Value=dat[,"TG"]*0.1,
                  Meta=rep("ECAD",nrow(dat)))
out$Value[which(dat[,"Q_TG"] %in% c(1,9))] <- NA
out <- check_dates(out)
refind <- which(out$Year %in% c(refper[1]:refper[2]))
out <- out[refind,]

write_sef(out[,1:6], outpath, "ta", "KAR_ta_ref", meta["V2"], 
          lat=lat, lon=lon, meta["V6"], sou="ECAD", link="",
          units ="C", stat="mean", period="day", metaHead = "",meta=out$Meta, note="daily", keep_na=TRUE)
