### create file from Lugano to check breaks for Milano, Padua, Bologna, etc.

source("code/data_prep/scripts/C000_helpfun.R")
refpath <- "code/data_prep/daymeans/refseries/"


pathd <- "data/mch/ths200d0/order_96190_data.txt"
pathl <- "data/mch/ths200d0/order_96190_legend.txt"

dat <- read.table(pathd, header = T, skip=2,na.strings = "-", sep=";")
meta <- read.table(pathl,skip=31,nrow=1,
                   colClasses = rep("character",7),strip.white=T)
clm <- "ths200d0"
ch <- fruitr::ch1903_to_wgs84(as.integer(c(substr(meta["V6"],1,6),substr(meta["V6"],8,14))))
xlon <- ch[1]
xlat <- ch[2]

out <- data.frame(Year=as.integer(substr(dat$time,1,4)),
                  Month=as.integer(substr(dat$time,5,6)),
                  Day=as.integer(substr(dat$time,7,8)),
                  Hour=rep(NA, nrow(dat)),
                  Minute=rep(NA, nrow(dat)),
                  Value=as.numeric(as.character(dat[,clm])),
                  Meta=rep("mchstn",nrow(dat)))
out <- check_dates(out)

climindvis <- make_object(tavg=t(out[,"Value"]), dates_tavg = pdate(out[,1:3]),lon=xlon,lat=xlat, data_info = list(type="p",date_format="t1d",data_name="NBCN"), data_range=c(1961,2020))
stnmons <- calc_index(climindvis, index="mean",var="tavg", aggt="monthly")
datf <- data.frame(year=rep(as.integer(stnmons$index_info$years),each=12),
                   mon= rep(c(1:12),length(stnmons$index_info$years)),
                   day=rep(00,length(rep(c(1:12),length(stnmons$index_info$years)))),
                   value= round(as.vector(stnmons$index[1,,]),2))
write.table(datf,file=paste0(refpath,"/hom_input_ref/LUG_ta_ref.dat"),quote=F,row.names = F,col.names = F)

rm(datf,climindvis,out)