#### create sef files from yuris merged series

path <- "data/EarlyInstrumentalTemperature/"
histmerged <- "code/data_prep/daymeans/histseries/merged/"

towns <- c("Basel","Bern","Zurich","Geneva")

meta<- list("Basel" = list(id = "BAS", cod = "", nam = "Basel", lat = 47.3653, lon = 7.34336, atl = 432, link = "", sou = "WeaR", units = "C", metaHead = ""),
            "Bern" = list(id = "BER", cod = "", nam = "Bern", lat = 46.947504, lon = 7.450855, atl = 542, link = "", sou = "WeaR", units = "C", metaHead = ""),
            "Zurich" = list(id = "SMA", cod = "", nam = "Zurich", lat = 47.371, lon = 8.534, atl = 420, link = "", sou = "WeaR", units = "C", metaHead = ""),
            "Geneva" = list(id = "GVE", cod = "", nam = "Geneva", lat = 46.19861, lon = 6.14527, atl = 380, link = "", sou = "WeaR", units = "C", metaHead = ""))

for(i in 1:length(towns)){
  
  file <- list.files(paste0(path,towns[i],"/4_merged/"),"daily", full.names = T)
  dat <- read.table(file, header = T, sep = ",")
  dat_df <- data.frame(year(dat$Date),month(dat$Date),day(dat$Date),rep(NA,nrow(dat)),rep(NA,nrow(dat)), dat$Ta_mean)
  
  write_sef(Data = dat_df,
            outpath = histmerged,
            variable = "ta",
            cod = meta[[towns[i]]][["id"]],
            nam = meta[[towns[i]]][["nam"]],
            lat = meta[[towns[i]]][["lat"]],
            lon = meta[[towns[i]]][["lon"]],
            alt = meta[[towns[i]]][["alt"]],
            link = meta[[towns[i]]][["link"]],
            sou = meta[[towns[i]]][["sou"]],
            units = meta[[towns[i]]][["units"]],
            stat = "mean",
            metaHead = meta[[towns[i]]][["metaHead"]],
            meta=paste(dat$Segment,"-",dat$Obs_times_UTC),
            period = "day",
            time_offset =0,
            keep_na = TRUE,
            note="")
  
}
