### 010 Masterscript
### 2022-07-29

rm(list=ls())

## for testing purpose
scen <- "all_temp"
dist <- "Gower"
startCal <- "1763-01-01"
endCal <- "1863-12-31"
calonly <- "T"
climoff <- "T"

args <- commandArgs(TRUE)
print(args)
scen <- args[1]
stnval <- args[2]
dist <- args[3]
startCal <- args[4]
endCal <- args[5]
calonly <- args[6]
climoff <- args[7]

#setwd("xxx")

###################################################################################################
### ANALOGUE METHOD
###################################################################################################

analogs <- T

source("C011_scenarios.R")

# Calibration of the analog method (list)
specifications <- list(
    variables = c("ta","p","rr","rr0"),     # "temp", "press", "prec", "precipitation occurrence"
    scenario = scen,                        # predefine a network in 011_scenarios.R based on variables and station for which the script should be run. 
    distance = dist,                        # "Euclid","RMSE","Mahalanobis","Gower". RMSE and weighted Euclid are the same!
    WT_sel=.95,                             # preselection of weather types (number or probability of WT)
    nAnalog = 50,                           # number of analogs
    startRef = "1961-01-01",                # start of reference period
    endRef = "2020-12-31",                  # end of reference period
    startCal = startCal,                    # calibration start year
    endCal = endCal,                        # calibration end year == this is end of historical period, i.e.scenario, not end of entire calibration
    calonly = ifelse(calonly=="T",T,F),     # do not include predictor dates in final analog files
    endHist = "1863-12-31",                 # historical period end year
    dayselection = 60,                      # analog dates only +-dayselection days from target date  
    standardize = T,                        # standardize data?
    trend = T,                              # correct temperature trend. This needs a file with the temperature trends already calculated.  
    offset = ifelse(climoff=="T",T,F),      # remove an climate offset of station data in reference period? Needs a file with the offset calculated.
    seasonality = T,                        # correct temperature seasonality
    sep_ref_hist =F,                        # if seasonality = T, should seasonality be removed separately for ref and hist?
    window=5,                               # number of days in reference period not to consider in analog pool for cross-validation
    rr0crit=""                              # should the preselection of analogs include as well the precipitation occurrence. If yes, which would be the threshold then? eg.0.5
)              


### load packages
source("C012_packages.R")

### load helpfunction
source("C013_helpfun.R")

###################################################################################################
### ANALOGUE RESAMPLING METHOD
###################################################################################################

### execute preprocessing according to specifications
source("C020_preprocessing.R")

## calculate analogues
source("C030_analogs.R")

